/* DSmeister software
 * Sensor interface
 *
 * Created: 2015/09/06
 *  Author: Yaasan
 */ 

#ifndef MSENSOR_H
#define MSENSOR_H

#include <Arduino.h>

#define		LV_LEVEL			167		// 1024d * (1 / 11) * 9V / 5V
#define		OC_LEVEL			154		// 7.5A
#define		OV_LEVEL			372		// 1024d * (1 / 11) * 20V / 5V


class MSensor
{
  private:
	
	unsigned char gSensor_Voltage;		/**< 1V unit(0V to 255V)   */
	unsigned short gSensor_Current;		/**< 0.01A unit(0.00A to 12.50A)   */
	int pinCurrent;
	int pinVoltage;
	int pinTemperature;
	word gOffset_Current;
	unsigned short gMonitoringCurrent;
	
  public:
	
	MSensor(int inPin_current, int inPin_voltage);
	
	unsigned char  Update(unsigned short inOCLevel);
	unsigned char GetCurrent();
	unsigned char GetVoltage();
	word GetCurrentOffset();
	void CalcCurrentOffset();
	void MonitorCurrent(void);
};

#endif
